Imports GTA
Imports GTA.Math
Imports System
Imports System.IO
Imports System.Text
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Threading.Tasks
Imports System.Collections.Generic

Public Module GlobalVariables
    Public RND As New Random

    Public isPlayerInMarker As Boolean = False
    Public CurrentHotel As Hotel = Nothing

    Public isSleeping As Boolean = False
    Public SuppressTrigger As Boolean = False

    Public IngameHour As Integer
    Public IngameMinute As Integer
    Public IngameDay As Integer

    Public ListOfHotels As New List(Of Hotel)

    Public Archipelago As New Hotel("The Archipelago", "We Are Truly Under Water", New Vector3(-1096.3, -324.3, 37.8), 15, 23, 11, 220, Color.CadetBlue)
    Public Richman As New Hotel("the Richman Hotel", "Because No Price Is Too High", New Vector3(-1274.2, 315.4, 65.5), 15, 23, 12, 765, Color.DarkSalmon)
    Public VCRich As New Hotel("the Von Crastenburg Richman", "Take A Bite Out Of The Upper Crust", New Vector3(-1213.8, -191.2, 39.3), 15, 23, 12, 409, Color.DarkOrchid)
    Public VCPB As New Hotel("the Von Crastenburg Pacific Bluffs", "Take A Bite Out Of The Upper Crust", New Vector3(-1858.2, -347.5, 49.8), 15, 23, 12, 850, Color.DarkOrchid)
    Public VCDP As New Hotel("the Von Crastenburg Del Perro", "Take A Bite Out Of The Upper Crust", New Vector3(-1545.1, -530.1, 36.1), 15, 23, 12, 330, Color.DarkOrchid)
    Public VCVine As New Hotel("the Von Crastenburg Vinewood", "Take A Bite Out Of The Upper Crust", New Vector3(435.9, 215.2, 103.2), 15, 23, 12, 499, Color.DarkOrchid)
    Public VCVesp As New Hotel("the Von Crastenburg Vespucci", "Take A Bite Out Of The Upper Crust", New Vector3(-667.4, -1105.1, 15.6), 15, 23, 12, 350, Color.DarkOrchid)
    Public VCLSIA As New Hotel("the Von Crastenburg LSIA", "Take A Bite Out Of The Upper Crust", New Vector3(-667.4, -1105.1, 15.6), 15, 23, 12, 350, Color.DarkOrchid)
    Public BannerDP As New Hotel("Banner Hotel Del Perro", "Flying The Banner", New Vector3(-1661.8, -533.7, 36), 16, 23, 11, 439, Color.Gainsboro)
    Public BannerPB As New Hotel("Banner Hotel & Spa, Pillbox Hill", "Flying The Banner", New Vector3(-287.2, -1061.6, 27.2), 16, 23, 11, 280, Color.Gainsboro)
    Public Venetian As New Hotel("The Venetian", "With Real Venetian Pigeons In Your Flooded Room!", New Vector3(-1361.9, -1078.2, 3.6), 15, 23, 12, 689, Color.YellowGreen)
    Public PerreraBeach As New Hotel("Perrera Beach Motel", "Because You Couldn't Afford Anything Else", New Vector3(-1477.2, -674.3, 29), 17, 23, 11, 175, Color.Gold)
    Public CrownJewels As New Hotel("Crown Jewels Motel", "Lay Your Jewels To Rest", New Vector3(-1309, -931, 13.4), 15, 23, 12, 180, Color.DodgerBlue)
    Public Generic As New Hotel("the Generic Hotel", "When You Sleep Here, You Could Be Sleeping Anywhere!", New Vector3(-478, 218.1, 83.7), 15, 23, 12, 269, Color.SkyBlue)
    Public Pegasus As New Hotel("the Pegasus Concierge Hotel", "Concierges Servicing You In Your Sleep", New Vector3(-310.3, 222.2, 87.9), 15, 23, 12, 485, Color.RoyalBlue)
    Public VineGar As New Hotel("the Vinewood Gardens Hotel", "By 'Garden View' We Really Mean 'Back Alley View'", New Vector3(328.8, -69.2, 73), 15, 23, 12, 510, Color.Red)
    Public Gentry As New Hotel("the Gentry Manor Hotel", "Recreate Yesterday's Famous Sex Tapes", New Vector3(-60.6, 360.2, 113.1), 15, 23, 12, 885, Color.LightGray)
    Public Viceroy As New Hotel("the Viceroy Hotel & Resort", "Pampering Your Royal Ass", New Vector3(-822.2, -1223.5, 7.4), 15, 23, 12, 589, Color.Purple)
    Public Emissary As New Hotel("The Emissary", "All Hail The Emissary! Kifflom!", New Vector3(104.8, -933, 29.8), 15, 23, 12, 670, Color.Gold)
    Public Elkridge As New Hotel("the Elkridge Hotel", "Yeah, There Are No Elk In Sight, Sorry", New Vector3(286.1, -936.5, 29.5), 15, 23, 12, 470, Color.LawnGreen)
    Public PinkCage As New Hotel("Pink Cage Motel", "Umm... We Don't Actually Offer Nightly Rates", New Vector3(313.1, -225.4, 54.2), 15, 23, 11, 85, Color.Pink)
    Public Alta As New Hotel("Alta Motel", "Don't Worry, The Rooms Aren't As Run-Down As Our Sign", New Vector3(64.4, -254.6, 48.2), 15, 23, 11, 95, Color.Teal)
    Public RockDor As New Hotel("the Rockford Dorset Hotel", "Absolutely None Of Our Valets Have Ever Stolen A Car!", New Vector3(-570.2, -395, 35.1), 15, 23, 12, 345, Color.OrangeRed)
    Public Bayview As New Hotel("Bayview Lodge", "Surrounded By Lots Of Hard Wood", New Vector3(-709.8, 5769, 17.5), 15, 23, 11, 65, Color.Brown)
    Public DreamView As New Hotel("Dream View Motel", "Dreaming Of A Better Paleto Bay", New Vector3(-104.9, 6315.9, 31.6), 15, 23, 11, 55, Color.Khaki)
    Public Eastern As New Hotel("Eastern Motel", "You Sure 'Bout This? You Seen Who Stays Here?", New Vector3(317.3, 2623.1, 44.5), 15, 23, 11, 59, Color.Tomato)
    Public Bilingsgate As New Hotel("Bilingsgate Motel", "Special Deal: Free Prostitute If You Pay For An Entire Night!!!!", New Vector3(570, -1746.6, 29.2), 15, 23, 11, 89, Color.Olive)
    Public Opium As New Hotel("Opium Nights Hotel", "Free Airplane Noise!", New Vector3(-737, -2276.2, 13.4), 15, 23, 11, 189, Color.Gold)
    Public Koi As New Hotel("the Koi Retreat & Spa", "It Sounds Like A Cool Place, Until You Actually See It", New Vector3(-1040.6, -1475.1, 5.6), 15, 23, 11, 559, Color.Indigo)
    Public Wisdahl As New Hotel("Hotel Wisdahl", "Huh, Didn't Realize We Were Still In Business", New Vector3(57.8, -1004.4, 29.4), 15, 23, 11, 125, Color.Red)

End Module

Public Class StayAtHotel
    Inherits Script

    Public Sub New()
        Me.Interval = 500
    End Sub

    Public Sub Update(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick

        updateIngameTime()

        CheckIfPlayerIsInMarker()

        If isSleeping = True Then FadeChecker()

    End Sub

    Public Sub updateIngameTime()
        IngameHour = World.CurrentDayTime.Hours
        IngameMinute = World.CurrentDayTime.Minutes
        IngameDay = GTA.Native.Function.Call(Of Integer)(Native.Hash.GET_CLOCK_DAY_OF_WEEK) 'MON = 0 / TUE = 1 / WED = 2 / THU = 3 / FRI = 4 / SAT = 5 / SUN = 6
    End Sub

    Public Sub CheckIfPlayerIsInMarker()

        Dim dist As Double
        Dim result As Hotel = Nothing

        For Each h As Hotel In ListOfHotels
            dist = World.GetDistance(Game.Player.Character.Position, h.Trigger)
            If dist < 2 Then
                result = h
                Exit For
            End If
        Next

        If result Is Nothing Then
            isPlayerInMarker = False
            CurrentHotel = Nothing
            SuppressTrigger = False
            isSleeping = False
        Else
            isPlayerInMarker = True
            CurrentHotel = result
        End If


    End Sub

    Public Sub KeyPressJ(ByVal sender As Object, ByVal k As KeyEventArgs) Handles MyBase.KeyUp

        If k.KeyCode <> Keys.NumPad5 Then Exit Sub
        If CurrentHotel Is Nothing Then Exit Sub
        'ALL CONDITIONS MET

        If Game.Player.Money < CurrentHotel.Price Then
            GTA.UI.Notify("Sorry, we don't have any rooms in your price range.")
            Exit Sub
        End If

        isSleeping = True

        '==> FADE TO BLACK
        GTA.Native.Function.Call(Native.Hash.DO_SCREEN_FADE_OUT, 2000)
    End Sub

    Public Sub FadeChecker()
        Dim isFadedOut As Boolean = GTA.Native.Function.Call(Of Boolean)(Native.Hash.IS_SCREEN_FADED_OUT)

        If isFadedOut = False Then Exit Sub

        SuppressTrigger = True

        '==> ADD TIME
        Dim target As Integer = 6
        Dim minimum As Integer = 0

        If IngameHour < target Then
            minimum = target - IngameHour
        Else
            minimum = 24 - IngameHour + target
        End If

        Dim hr As Integer = RND.Next(minimum, minimum + 4)
        Dim mn As Integer = RND.Next(0, 60)
        GTA.Native.Function.Call(Native.Hash.ADD_TO_CLOCK_TIME, hr, mn, 0)

        '==> SUBTRACT MONEY
        Dim currentMoney = Game.Player.Money
        Game.Player.Money = currentMoney - CurrentHotel.Price

        '==> AUTOSAVE
        GTA.Native.Function.Call(Native.Hash.DO_AUTO_SAVE)

        '==> NOTIFY
        GTA.UI.Notify("You slept for " & hr & " hours and " & mn & " minutes. Thank you for staying at " & CurrentHotel.Name & "!")

        '==> FADE IN
        GTA.Native.Function.Call(Native.Hash.DO_SCREEN_FADE_IN, 2000)
    End Sub

End Class

Public Class StayAtHotelUI
    Inherits Script

    Public UI_Trigger_width As Integer = 450
    Public UI_Trigger_height As Integer = 200
    Public UI_Trigger_x As Integer = (1280 / 2) - (UI_Trigger_width / 2)
    Public UI_Trigger_y As Integer = (720 / 2) - (UI_Trigger_height / 2)
    Public UI_Trigger As New UIContainer(New Point(UI_Trigger_x, UI_Trigger_y), New Size(UI_Trigger_width, UI_Trigger_height), Color.FromArgb(0, 0, 0, 0))

    Public Sub Refresh(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick

        DrawMarkers()

        If SuppressTrigger = True Then Exit Sub
        If isPlayerInMarker = True Then DrawLobbyMessage()

    End Sub

    Public Sub DrawMarkers()
        For Each h As Hotel In ListOfHotels
            World.DrawMarker(MarkerType.ChevronUpx1, h.Trigger, New Vector3(0, 0, 0), New Vector3(0, 180, 0), New Vector3(1, 1, 1), Color.FromArgb(20, Color.Yellow), True, True, 0, False, "", "", False)
        Next
    End Sub

    Public Sub DrawLobbyMessage()
        With UI_Trigger
            .Items.Clear()
            .Items.Add(New UIRectangle(New Point(0, 0), New Size(UI_Trigger_width, UI_Trigger_height), CurrentHotel.ColorScheme))
            .Items.Add(New UIRectangle(New Point(2, 2), New Size(UI_Trigger_width - 4, UI_Trigger_height - 4), Color.Black))
            .Items.Add(New UIRectangle(New Point(2, 2), New Size(UI_Trigger_width - 4, 55), CurrentHotel.ColorScheme))
            .Items.Add(New UIText("Welcome to " & CurrentHotel.Name, New Point(UI_Trigger_width / 2, 6), 0.7, Color.Black, GTA.Font.HouseScript, True))
            .Items.Add(New UIText(CurrentHotel.Slogan, New Point(UI_Trigger_width / 2, 35), 0.3, Color.Black, GTA.Font.ChaletLondon, True))
            '.Items.Add(New UIText("Check-in: " & CurrentHotel.CheckInStartTime & ":00 to " & CurrentHotel.CheckInEndTime & ":00   /   Last Check-out: " & CurrentHotel.CheckOutTime & ":00", New Point(UI_Trigger_width / 2, 60), 0.3, Color.White, GTA.Font.ChaletLondon, True))
            .Items.Add(New UIText("Price: $" & CurrentHotel.Price & ".00", New Point(UI_Trigger_width / 2, 100), 0.5, Color.White, GTA.Font.ChaletLondon, True))
            .Items.Add(New UIText("Press Numpad 5 to sleep at this hotel.", New Point(UI_Trigger_width / 2, 170), 0.3, Color.LightGray, GTA.Font.ChaletLondon, True))
            .Draw()
        End With
    End Sub

End Class

Public Class Hotel
    Public Name As String
    Public Slogan As String
    Public Trigger As Vector3
    Public Price As Integer
    Public CheckInStartTime As Integer
    Public CheckInEndTime As Integer
    Public CheckOutTime As Integer
    Public ColorScheme As Color

    Public Enum HotelType
        Luxury
        Midrange
        Poor
    End Enum

    Public Sub New(name As String, slog As String, position As Vector3, checkinstart As Integer, checkinend As Integer, checkout As Integer, price As Integer, col As Color)
        Me.Name = name
        Me.Slogan = slog
        Me.Trigger = position
        Me.CheckInStartTime = checkinstart
        Me.CheckInEndTime = checkinend
        Me.CheckOutTime = checkout
        Me.Price = price
        Me.ColorScheme = col
        ListOfHotels.Add(Me)
    End Sub
End Class